#! /bin/bash
#
cmlib_src="$HOME/install/cmlib3/src/"
# --------------------------------------------------------------------------
dir=`pwd | sed -e 's|.*/f2cad/||' -e 's|.*/f2cAD/||'`
if [ "$dir" != "trunk" ]
then
	echo "cmlib_require.sh: must exectue this routine from the trunk"
	exit 1
fi
if [ "$1" == "" ]
then
	echo "purpose: list of routines required before a specified routine"
	echo "usage:   ./cmlib_require.sh routine"
	echo "routine: is a Fortran source file name (with out extension)"
	exit 1
fi
file=`find $cmlib_src -name "$1.f"`
if [ "$file" == "" ]
then
	echo "cmlib_require.sh: cannot find $1.f below $cmlib_src directory"
	exit 1
fi
check_next="$1"
#
# s88fmt (mistakes in source)
# i1mach (defined by f2cad/trunk/lib/i1mach.cpp)
# d1mach (defined by f2cad/trunk/lib/d1mach.cpp)
# r1mach (converted by c2cpp.sed to d1mach)
# xerror (defined by f2cad/trunk/lib/xerror.cpp)
for_list=`
	ls fortran/*.f | 
	sed -e 's|fortran/||' -e 's|\.f||' |
	tr '\n' ' '
`
list_done=" $for_list s88fmt i1mach d1mach r1mach xerror "
#
while [ "$check_next" != "" ]
do
	check_now="$check_next"
	check_next=""
	for name in $check_now
	do
		file=`find $cmlib_src -name "$name.f"`
		if [ "$file" == "" ]
		then
			echo "cmlib_require.sh: cannot file $name.f"
			exit 1
		fi
		depend=`
			grep '^C\**ROUTINES CALLED' $file | 
			sed -e 's/^C\**ROUTINES CALLED//' -e 's/,/ /g' -e 's/(NONE)//' |
			tr [A-Z] [a-z]
		`
		for name in $depend
		do
			if ! echo "$list_done" | grep " $name " > /dev/null
			then
				find $cmlib_src -name "$name.f"
				check_next="$check_next $name "
			fi
		done
		list_done="$list_done $check_next"
	done
done
